<?php

namespace ByDedi\Module\CustomForm\Back;

use BackModule;
use Query;
use BackForm;
use Boutique;
use BackLabel;

// phpcs:disable
class bForm extends BackModule
{
    public function __construct($formvars = array())
    {
        parent::__construct($formvars);
        $GLOBALS['displayMcFileManager'] = true;
        $GLOBALS['displayMcImageManager'] = true;
        $this->docs = [
            "Global" => __DIR__ . "/doc/form/index.md",
            "Réponses" => __DIR__ . "/doc/responses/index.md",
        ];
    }

    public function update($formvars = array(), $table = null, $langue = true)
    {
        parent::update_multi($formvars, $table, $langue);
    }

    public function create($formvars = array(), $table = null, $langue = true)
    {
        $formId = parent::create_multi($formvars, $table, $langue);
        Boutique::getInstance()->createStatut('form', $formId);

        return $formId;
    }

    public function delete($formvars = array())
    {
        parent::delete_multi($formvars);
    }

    public function Form($formvars = array())
    {

        if (empty($formvars['id'])) {
            $this->path[] = "<span> &raquo; <a href='" . $this->link_to('addForm') . "'>"
                . "Ajout d'un nouveau formulaire</a></span>";
        } else {
            $sql = "SELECT form_nom_nom as data FROM form_nom WHERE form_id = '" . $formvars['id']
                . "' AND langue_id = '" . Boutique::getInstance()->getLangue()->id . "'";
            $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
            $data = $this->sql->record[0];
            $this->path[] = "<span> &raquo; <a href='" . $this->link_to(
                    'modForm',
                    array('id' => $formvars['id'])
                ) . "'>Edition du formulaire : <strong>" . $data['data'] . "</strong></a></span>";
        }

        // SQL
        if (!empty($formvars['id'])) {
            $query = $this->getFormQuery($formvars);
            $this->request = $query->build();
        }

        $form = new BackForm("Informations du Formulaire", "group");
        $this->addForm($form);

        $this->mainInfoGroup($formvars);

        $form = new BackForm("Champs", "group");
        $form->addGroupOpts('class', 'form_field');
        $this->addForm($form);

        $form = new BackForm("Reponses", "group");
        $form->addGroupOpts('class', 'form_response');
        $this->addForm($form);

        $form = new BackForm("Boutiques", "group");
        $form->addGroupOpts('class', 'form_boutique');
        $this->addForm($form);

        //-- Champs du formulaire
        if (!isset($formvars['id'])) {
            $formvars['id'] = 0;
        }

        $formvars += [
            'id' => 0,
            'div' => ''
        ];

        return $this->displayForm($formvars['id'], $formvars['div']);
    }

    public function Listing($formvars = array())
    {
        $query = new Query();
        $boutique = Boutique::getInstance();

        $query
            ->select(
                'f.form_id',
                'f.form_id',
                'fn.form_nom_nom',
                'COUNT(DISTINCT ff.form_field_id)',
                'COUNT(DISTINCT fr.form_response_id)'
            )
            ->from('form')
            ->leftJoin('form_nom', "AND", ['fn.form_id', 'f.form_id'], ['fn.langue_id', $boutique->getLangue()->id])
            ->leftJoin('form_field', 'ff.form_id', 'f.form_id')
            ->leftJoin('form_response', 'fr.form_id', 'f.form_id')
        ;

        $this->request = $query->build();
        //-- SQL
        // LABELS
        $label = new BackLabel("ID");
        $this->addLabel($label);

        $label = new BackLabel("NOM");
        $this->addLabel($label);

        $label = new BackLabel("CHAMPS", 'listselect');
        $label->setVar('option', array("module" => "<a href='../../form_field/list/?ff*form_id=%ID%'>%IMG%</a>"));
        $this->addLabel($label);

        $label = new BackLabel("REPONSES", 'listselect');
        $label->setVar('option', array("module" => "<a href='../../form_response/list/?fr*form_id=%ID%'>%IMG%</a>"));
        $this->addLabel($label);

        return $this->displayList($formvars['type']);
    }

    /**
     * @param array $formvars
     *
     * @SuppressWarnings("unused")
     */
    protected function mainInfoGroup(array $formvars = [])
    {
        $form = new BackForm("Statut", 'select', "form_statut_id");
        $arr = [1 => 'Active', 0 => 'Disabled',];
        foreach ($arr as $value => $name) {
            $form->addOption($value, $name);
        }
        $this->addForm($form);
        $form = new BackForm("Nom", 'text', 'form_nom_nom');
        $form->setVar('translate', true);

        $this->addForm($form);
        $form = new BackForm("Texte du bouton de soumission", 'text', 'form_nom_submit_text');
        $form->setVar('translate', true);
        $this->addForm($form);

        $form = new BackForm("Message de confirmation", 'text', 'form_nom_success');
        $form->setVar('translate', true);
        $form->setVar('comment', "Message apparaissant une fois que le formulaire a été enregistré");
        $this->addForm($form);
    }

    /**
     * @param $formvars
     * @return Query
     */
    protected function getFormQuery($formvars)
    {
        $query = new Query();
        $query->select('*')
            ->from('form')
            ->innerJoin(
                'form_nom',
                'AND',
                ['fn.form_id', 'f.form_id'],
                ['fn.langue_id', Boutique::getInstance()->getLangue()->id]
            )
            ->where('f.form_id', $formvars['id'])
        ;
        return $query;
    }

//--
}
