<?php

namespace ByDedi\Module\CustomForm\Back;

use BackModule;
use Form\FullForm\FieldInterface;
use Query;
use BackForm;
use Boutique;
use BackLabel;

// phpcs:disable
class bForm_field extends BackModule
{
    public function __construct($formvars = array())
    {
        parent::__construct($formvars);
    }

    public function update($formvars = array(), $table = null, $langue = true)
    {
        parent::update_multi($formvars, $table, $langue);
    }

    public function create($formvars = array(), $table = null, $langue = true)
    {
        $formFieldId = parent::create_multi($formvars, $table, $langue);
        Boutique::getInstance()->createStatut('form_field', $formFieldId);

        return $formFieldId;
    }

    public function delete($formvars = array(), $table = null, $langue = true)
    {
        parent::delete_multi($formvars, $table, $langue);
    }

    public function Form($formvars = array())
    {

        if (empty($formvars['id'])) {
            $this->path[] = "<span> &raquo; <a href='" . $this->link_to('addForm') . "'>"
                . "Ajout d'un nouveau champs</a></span>";
        } else {
            $sql = "SELECT form_field_nom_nom as data FROM form_field_nom"
                . " WHERE form_field_id = '" . $formvars['id']
                . "' AND langue_id = '" . Boutique::getInstance()->getLangue()->id . "'";
            $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
            $data = $this->sql->record[0];
            $this->path[] = "<span> &raquo; <a href='" . $this->link_to(
                    'modForm',
                    array('id' => $formvars['id'])
                ) . "'>Edition du champs : <strong>" . $data['data'] . "</strong></a></span>";
        }

        // SQL
        if (!empty($formvars['id'])) {
            $query = $this->getFormQuery($formvars);
            $this->request = $query->build();

            $field = $this->sql->getOne($this->request);
        }

        $form = new BackForm("Informations du Champs", "group");
        $this->addForm($form);

        $form = new BackForm("Nom", 'text', 'form_field_nom_nom');
        $form->setVar('translate', true);
        $this->addForm($form);
        $this->mainInfoGroup($formvars);

        if (
            !empty($field)
            && $this->isTypeWithOptions($field['form_field_type_id'])
        ) {
            $form = new BackForm("Options", "group");
            $form->addGroupOpts('class', 'form_field_option');
            $this->addForm($form);
        }

        $form = new BackForm("Constraints", "group");
        $form->addGroupOpts('class', 'form_field_constraint');
        $this->addForm($form);

        $form = new BackForm("Boutiques", "group");
        $form->addGroupOpts('class', 'form_field_boutique');
        $this->addForm($form);

        //-- Champs du formulaire
        $formvars += [
            'id' => 0,
            'div' => ''
        ];

        return $this->displayForm($formvars['id'], $formvars['div']);
    }

    public function Listing($formvars = array())
    {
        $boutique = Boutique::getInstance();
        $query = new Query();
        $query
            ->select(
                'f.form_id',
                'fn.form_nom_nom'
            )
            ->from('form')
            ->leftJoin('form_nom', "AND", ['fn.form_id', 'f.form_id'], ['fn.langue_id', $boutique->getLangue()->id])
        ;

        $form = new BackForm("Form", "select", "ff.form_id");
        $form->addOptionSQL([$query->build()]);
        $this->addForm($form);
        $query = $this->getListingQuery($formvars);

        $this->request = $query->build();
        //-- SQL
        // LABELS
        $this->addListingLabels();

        return $this->displayList($formvars['type']);
    }

    /**
     * @param $formvars
     */
    protected function mainInfoGroup($formvars)
    {
        if (!empty($formvars['form']) || !empty($formvars['form_id'])) {
            $form = new BackForm("Form", 'hidden', 'form_id');
            $this->addForm($form);
        } elseif (empty($formvars['id'])) {
            $query = new Query();
            $query->select('f.form_id', 'fn.form_nom_nom')->from('form')->leftJoin('form_nom', "AND", ['fn.form_id', 'f.form_id'], ['fn.langue_id', LANGUE]);
            $form = new BackForm("Formulaire", "select", "form_id");
            $form->addOptionSQL([$query->build()]);
            $this->addForm($form);
        }
        $form = new BackForm("Statut", 'select', "form_field_statut_id");
        $arr = [1 => 'Active', 0 => 'Disabled',];
        foreach ($arr as $value => $name) {
            $form->addOption($value, $name);
        }
        $this->addForm($form);
        $form = new BackForm("Type", 'select', "form_field_type_id");
        $form->addOptionSQL(["SELECT form_field_type_id, form_field_type_libelle FROM form_field_type"]);
        $this->addForm($form);

        $form = new BackForm("Rang", 'text', "form_field_rang");
        $this->addForm($form);

        $form = new BackForm("Tags", 'text', "form_field_tag");
        $form->setVar('comment', 'Les tags servent à identifier un champs. Les tags doivent être séparés par des espaces');
        $this->addForm($form);
    }

    /**
     * @param $formvars
     * @return Query
     */
    protected function getFormQuery($formvars)
    {
        $query = new Query();
        $query
            ->select('*')
            ->from('form_field')
            ->innerJoin('form_field_nom', 'ffn.form_field_id', 'ff.form_field_id')
            ->where('ff.form_field_id', $formvars['id'])
        ;
        return $query;
    }

    /**
     * @param $form_field_type_id
     * @return bool
     */
    protected function isTypeWithOptions($form_field_type_id)
    {
        return in_array(
            $form_field_type_id,
            [
                FieldInterface::TYPE_SELECT_ID,
                FieldInterface::TYPE_RADIO_ID
            ]
        );
    }

    /**
     * @param $formvars
     * @return Query
     */
    protected function getListingQuery($formvars)
    {
        $boutique = Boutique::getInstance();

        $query = new Query();
        $query->select(
            'ff.form_field_id',
            'ff.form_field_id',
            'ff.form_field_rang',
            'ffn.form_field_nom_nom',
            'fft.form_field_type_libelle'
        )
            ->from('form_field')
            ->leftJoin('form_field_type', 'fft.form_field_type_id', 'ff.form_field_type_id')
            ->leftJoin('form_field_nom', "AND", ['ffn.form_field_id', 'ff.form_field_id'], ['ffn.langue_id', $boutique->getLangue()->id])
            ->where(1)
        ;

        if (!empty($formvars['form'])) {
            $query->where('ff.form_id', $formvars['form']);
        }

        return $query;
    }

    protected function addListingLabels()
    {
        $label = new BackLabel("ID");
        $this->addLabel($label);

        $label = new BackLabel("RANG");
        $this->addLabel($label);

        $label = new BackLabel("NOM");
        $this->addLabel($label);

        $label = new BackLabel("TYPE");
        $this->addLabel($label);
    }

//--
}
