<?php

namespace ByDedi\Module\CustomForm\Back;

use BackForm;
use BackLabel;
use BackModule;
use Boutique;
use Query;

// phpcs:disable
class bForm_field_constraint extends BackModule
{
    public function __construct($formvars = array())
    {
        parent::__construct($formvars);
    }

    public function update($formvars = array(), $table = null, $langue = true)
    {
        parent::update_multi($formvars, $table, $langue);
    }

    public function create($formvars = array(), $table = null, $langue = true)
    {
        $constraintId = parent::create_multi($formvars, $table, $langue);
        Boutique::getInstance()->createStatut('form_field_constraint', $constraintId);

        return $constraintId;
    }

    public function delete($formvars = array(), $table = null, $langue = true)
    {
        parent::delete_multi($formvars, $table, $langue);
    }

    public function Form($formvars = array())
    {

        if (empty($formvars['id'])) {
            $this->path[] = "<span> &raquo; <a href='" . $this->link_to('addForm') . "'>"
                . "Ajout d'une nouvelle contrainte</a></span>";
        } else {
            $this->path[] = "<span> &raquo; <a href='" . $this->link_to(
                'modForm',
                array('id' => $formvars['id'])
            ) . "'>Edition de la contrainte : <strong>" . $formvars['id'] . "</strong></a></span>";
        }

        // SQL
        if (!empty($formvars['id'])) {
            $sql = getTableMutli('form_field_constraint', $formvars['id']);
            $this->request = $sql;
        }

        $form = new BackForm("Informations de la Constraint", "group");
        $this->addForm($form);

        $form = new BackForm("Field", 'hidden', 'form_field_id');
        $this->addForm($form);

        $form = new BackForm("Constraint", 'select', "form_constraint_id");
        $form->addOptionSQL(["SELECT form_constraint_id, form_constraint_libelle FROM form_constraint"]);
        $this->addForm($form);

        $form = new BackForm("Message d'erreur", "text", 'form_field_constraint_nom_error');
        $form->setVar('translate', true);
        $this->addForm($form);

        $form = new BackForm("Boutiques", "group");
        $form->addGroupOpts('class', 'form_field_constraint_boutique');
        $this->addForm($form);

        //-- Champs du formulaire
        $formvars += [
            'id' => 0,
            'div' => ''
        ];

        return $this->displayForm($formvars['id'], $formvars['div']);
    }

    public function Listing($formvars = array())
    {
        $query = new Query();
        $query->select(
            'ffc.form_field_constraint_id',
            'ffc.form_field_constraint_id',
            'fc.form_constraint_libelle'
        )
            ->from('form_field_constraint')
            ->leftJoin('form_constraint', 'fc.form_constraint_id', 'ffc.form_constraint_id')
        ;

        if (!empty($formvars['form_field'])) {
            $query->where('ffc.form_field_id', $formvars['form_field']);
        }

        $this->request = $query->build();
        //-- SQL
        // LABELS
        $label = new BackLabel("ID");
        $this->addLabel($label);

        $label = new BackLabel("CONSTRAINT");
        $this->addLabel($label);

        return $this->displayList($formvars['type']);
    }

//--
}
