<?php

namespace ByDedi\Module\CustomForm\Back;

use BackForm;
use BackLabel;
use BackModule;
use Boutique;
use Query;

// phpcs:disable
class bForm_field_option extends BackModule
{
    public function __construct($formvars = array())
    {
        parent::__construct($formvars);
    }

    public function update($formvars = array(), $table = null, $langue = true)
    {
        parent::update_multi($formvars, $table, $langue);
    }

    public function create($formvars = array(), $table = null, $langue = true)
    {
        return parent::create_multi($formvars, $table, $langue);
    }

    public function delete($formvars = array(), $table = null, $langue = true)
    {
        parent::delete_multi($formvars, $table, $langue);
    }

    public function Form($formvars = array())
    {

        if (empty($formvars['id'])) {
            $this->path[] = "<span> &raquo; <a href='" . $this->link_to('addForm') . "'>"
                . "Ajout d'une nouvelle option</a></span>";
        } else {
            $sql = "SELECT form_field_option_nom_nom as data FROM form_field_option_nom"
                . " WHERE form_field_option_id = '" . $formvars['id']
                . "' AND langue_id = '" . Boutique::getInstance()->getLangue()->id . "'";
            $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
            $data = $this->sql->record[0];
            $this->path[] = "<span> &raquo; <a href='" . $this->link_to(
                    'modForm',
                    array('id' => $formvars['id'])
                ) . "'>Edition de l'option : <strong>" . $data['data'] . "</strong></a></span>";
        }

        // SQL
        if (!empty($formvars['id'])) {
            $sql = $this->getFormQuery($formvars)->build();
            $this->request = $sql;
        }

        $form = new BackForm("Informations de l'option", "group");
        $this->addForm($form);

        $this->mainInfoGroup($formvars);

        //-- Champs du formulaire
        $formvars += [
            'id' => 0,
            'div' => ''
        ];

        return $this->displayForm($formvars['id'], $formvars['div']);
    }

    public function Listing($formvars = array())
    {
        $query = new Query();
        $boutique = Boutique::getInstance();
        $query->select(
            'ffo.form_field_option_id',
            'ffo.form_field_option_id',
            'ffo.form_field_option_rang',
            'ffo.form_field_option_value',
            'ffon.form_field_option_nom_nom'
        )
            ->from('form_field_option')
            ->leftJoin(
                'form_field_option_nom',
                "AND",
                ['ffon.form_field_option_id', 'ffo.form_field_option_id'],
                ['ffon.langue_id', $boutique->getLangue()->id]
            )
        ;

        if (!empty($formvars['form_field'])) {
            $query->where('ffo.form_field_id', $formvars['form_field']);
        }

        $this->request = $query->build();
        //-- SQL
        // LABELS
        $label = new BackLabel("ID");
        $this->addLabel($label);

        $label = new BackLabel("RANG");
        $this->addLabel($label);

        $label = new BackLabel("VALEUR");
        $this->addLabel($label);

        $label = new BackLabel("NOM");
        $this->addLabel($label);

        return $this->displayList($formvars['type']);
    }

    /**
     * @param array $formvars
     *
     * @SuppressWarnings("unused")
     */
    protected function mainInfoGroup(array $formvars = [])
    {
        $form = new BackForm("Field", 'hidden', 'form_field_id');
        $this->addForm($form);
        $form = new BackForm("Nom", 'text', 'form_field_option_nom_nom');
        $form->setVar('translate', true);
        $this->addForm($form);
        $form = new BackForm("Valeur", 'text', "form_field_option_value");
        $form->setVar("comment", "Correspond à ce qui sera enregistré dans la réponse");
        $this->addForm($form);
        $form = new BackForm("Rang", 'text', "form_field_option_rang");
        $this->addForm($form);
    }

    /**
     * @param $formvars
     * @return Query
     */
    protected function getFormQuery($formvars)
    {
        $query = new Query();
        $query
            ->select()
            ->from('form_field_option')
            ->innerJoin(
                'form_field_option_nom',
                'AND',
                ['ffon.form_field_option_id', 'ffo.form_field_option_id'],
                ['ffon.langue_id', Boutique::getInstance()->getLangue()->id]
            )
            ->where('ffo.form_field_option_id', $formvars['id'])
        ;
        return $query;
    }

//--
}
