<?php
/**
 * Created by PhpStorm.
 * User: gabriel
 * Date: 10/09/18
 * Time: 13:06
 */

namespace ByDedi\Module\CustomForm\Model;

use ByDedi\Module\CustomForm\Service\NoIdException;
use Form\FullForm\OptionInterface;

/**
 * Class FormResponseField
 *
 * @property int $form_field_id
 * @property int $form_response_id
 * @property string $form_field_response_value
 * @property int $form_field_option_id
 */
interface FieldResponseInterface
{
    /**
     * @return FieldEntityInterface
     */
    public function getFormField();

    /**
     * @return string
     */
    public function getValue();

    /**
     * @return OptionInterface|null
     */
    public function getOption();

    /**
     * @return bool
     */
    public function hasId();

    /**
     * @return integer
     * @throws NoIdException
     */
    public function getId();
}
