<?php

namespace ByDedi\Module\CustomForm\Model;

/**
 *
 */
class Model extends \Model
{
    /**
     * @param array $formvars
     * @return static[]
     */
    public function getLoaded($formvars = [])
    {
        $arr = $this->get($formvars);
        return $this->hydrateArray($arr);
    }

    /**
     * @param array $formvars
     * @return static|null
     */
    public function getOneLoaded($formvars = [])
    {
        $arr = $this->getOne($formvars);
        if (empty($arr)) {
            return null;
        }
        return $this->generate($arr);
    }

    /**
     * @param $arr
     * @return array
     */
    protected function hydrateArray($arr)
    {
        return array_map(function (array $arr) {
            return $this->generate($arr);
        }, $arr);
    }

    /**
     * @param $row
     * @return static
     */
    protected function generate($row)
    {
        $entity = new static();
        $entity->hydrate($row);
        return $entity;
    }
}
