<?php

namespace ByDedi\Module\CustomForm\Model;

/**
 * Class OptionRepository
 */
class OptionRepository extends Model
{
    protected $table = "form_field_option";

    protected function generate($row)
    {
        $entity = new Option(
            $row['form_field_option_id'],
            $row['form_field_option_value'],
            $row['form_field_option_nom_nom']
        );
        $entity->hydrate($row);
        return $entity;
    }

    /**
     * @param array $formvars
     * @return Option[]
     */
    public function getLoaded($formvars = [])
    {
        return parent::getLoaded($formvars);
    }

    /**
     * @param array $formvars
     * @return null|Option
     */
    public function getOneLoaded($formvars = [])
    {
        return parent::getOneLoaded($formvars);
    }

    public function getQuery($formvars = [])
    {
        $query = parent::getQuery($formvars);
        $query->order('ffo.form_field_option_rang');
        return $query;
    }

    /**
     * @param FieldEntityInterface $fieldEntity
     * @return Option[]
     */
    public function getByField(FieldEntityInterface $fieldEntity)
    {
        if (empty($fieldEntity->getId())) {
            trigger_error("Not loaded FormFieldEntity provided in " . __METHOD__);
            return [];
        }
        return $this->getLoaded(['ffo.form_field_id' => $fieldEntity->getId()]);
    }
}
