<?php
// phpcs:disable

use Phinx\Migration\AbstractMigration;

class FormResponse extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $this->table('form_response', ['id' => 'form_response_id'])
            ->addColumn('form_id', 'integer')
            ->addForeignKey(
                'form_id',
                'form',
                'form_id',
                ['delete' => 'CASCADE', 'update' => 'CASCADE']
            )
            ->create()
        ;

        $this->table('form_field_response', ['id' => 'form_field_response_id'])
            ->addColumn('form_field_id', 'integer')
            ->addColumn('form_response_id', 'integer')
            ->addColumn('form_field_response_value', 'text')
            ->addForeignKey(
                'form_field_id',
                'form_field',
                'form_field_id',
                ['delete' => 'CASCADE', 'update' => 'CASCADE']
            )
            ->addForeignKey(
                'form_response_id',
                'form_response',
                'form_response_id',
                ['delete' => 'CASCADE', 'update' => 'CASCADE']
            )
            ->create()
        ;
    }
}
