<?php
// phpcs:disable
use ByDedi\Module\CustomForm\Back\bForm;
use ByDedi\Module\CustomForm\Back\bForm_boutique;
use ByDedi\Module\CustomForm\Back\bForm_field;
use ByDedi\Module\CustomForm\Back\bForm_field_boutique;
use ByDedi\Module\CustomForm\Back\bForm_field_constraint;
use ByDedi\Module\CustomForm\Back\bForm_field_constraint_boutique;
use ByDedi\Module\CustomForm\Back\bForm_field_option;
use ByDedi\Module\CustomForm\Back\bForm_response;
use Phinx\Migration\AbstractMigration;

class BackModuleForm extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     *
     * @SuppressWarnings(PHPMD.ExcessiveMethodLength)
     */
    public function change()
    {
        $this->table('back_module')
            ->insert(
                [
                    [
                        'module_parent_id' => 246,
                        'module_nom' => 'Gestion des formulaires',
                        'module_titre' => 'Formulaires',
                        'module_page' => 'form',
                        'module_rang' => '130',
                        'actif_id' => 1,
                        'module_order' => 2,
                        'module_bases' => 'form|form_nom',
                        'module_class' => bForm::class,
                        'module_limit' => 50,
                        'module_group' => 'f.form_id'
                    ],
                    [
                        'module_parent_id' => 246,
                        'module_nom' => 'Gestion des Formulaires Boutique',
                        'module_titre' => 'Formulaires Boutique',
                        'module_page' => 'form_boutique',
                        'module_rang' => '130',
                        'actif_id' => 2,
                        'module_order' => 2,
                        'module_bases' => 'form_boutique',
                        'module_class' => bForm_boutique::class,
                        'module_limit' => 50,
                    ],
                    [
                        'module_parent_id' => 246,
                        'module_nom' => 'Gestion des Champs de formulaires',
                        'module_titre' => 'Champs de formulaires',
                        'module_page' => 'form_field',
                        'module_rang' => '130',
                        'actif_id' => 2,
                        'module_order' => 2,
                        'module_bases' => 'form_field|form_field_nom',
                        'module_class' => bForm_field::class,
                        'module_limit' => 50,
                    ],
                    [
                        'module_parent_id' => 246,
                        'module_nom' => 'Gestion des Champs de formulaires Boutique',
                        'module_titre' => 'Champs de formulaires Boutique',
                        'module_page' => 'form_field_boutique',
                        'module_rang' => '130',
                        'actif_id' => 2,
                        'module_order' => 2,
                        'module_bases' => 'form_field_boutique',
                        'module_class' => bForm_field_boutique::class,
                        'module_limit' => 50,
                    ],
                    [
                        'module_parent_id' => 246,
                        'module_nom' => 'Gestion des Constraints de Champs de formulaire',
                        'module_titre' => 'Constraints de Champs de formulaire',
                        'module_page' => 'form_field_constraint',
                        'module_rang' => '130',
                        'actif_id' => 2,
                        'module_order' => 2,
                        'module_bases' => 'form_field_constraint|form_field_constraint_nom',
                        'module_class' => bForm_field_constraint::class,
                        'module_limit' => 50,
                    ],
                    [
                        'module_parent_id' => 246,
                        'module_nom' => 'Gestion des Constraints de Champs de formulaire par Boutique',
                        'module_titre' => 'Constraints de formulaires par Boutique',
                        'module_page' => 'form_field_constraint_boutique',
                        'module_rang' => '130',
                        'actif_id' => 2,
                        'module_order' => 2,
                        'module_bases' => 'form_field_constraint_boutique',
                        'module_class' => bForm_field_constraint_boutique::class,
                        'module_limit' => 50,
                    ],
                    [
                        'module_parent_id' => 246,
                        'module_nom' => 'Gestion des Options de Champs de formulaire',
                        'module_titre' => 'Options de Champs de formulaire',
                        'module_page' => 'form_field_option',
                        'module_rang' => '130',
                        'actif_id' => 2,
                        'module_order' => 2,
                        'module_bases' => 'form_field_option|form_field_option_nom',
                        'module_class' => bForm_field_option::class,
                        'module_limit' => 50,
                    ],
                    [
                        'module_parent_id' => 246,
                        'module_nom' => 'Gestion des Réponse de formulaires',
                        'module_titre' => 'Réponse de formulaires',
                        'module_page' => 'form_response',
                        'module_rang' => '130',
                        'actif_id' => 2,
                        'module_order' => -3,
                        'module_bases' => 'form_response',
                        'module_class' => bForm_response::class,
                        'module_limit' => 50,
                    ],
                ]
            )
            ->saveData()
        ;
    }
}
